#include <errno.h>
#include <fcntl.h>
#include <ioctl.h>
#include <stdio.h>
#include <signal.h>
#include <osbind.h>
#include "lpr.h"

 
void catchsig(signo)
int signo;
{
	Lpr_h hd;
	FILE  *fd,*err;

	get_semaphore();
	fd = fopen(LPRSTAT,"rb+");
	fread(&hd,sizeof(hd),1,fd);
	hd.lpd = DIED;
	rewind(fd);
	fwrite(&hd,sizeof(hd),1,fd);
	fclose(fd);
	err = fopen(LPRMESS,"a");
	fprintf(err,"lpd: caught signal %d\n",signo);
	fclose(err);
	destroy_semaphore();
	exit(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
	FILE	*fd, *err;
	Lpr_h	hd;
	Lpr_d	dt;
	long	seks;
	void	catchsig();
	int		i;

#ifndef NODEAMON
	switch ( fork()) {
		case 0:
			/* This is the new deamon process */
#ifdef OLD_MINT
			/* kill the parent process, because it's stoped */
			Pkill(Pgetppid(),SIGKILL);
#endif
			break;
		case ENOMEM:
			printf("Not enough space!!!\n");
			exit( ENOMEM);	/* Error appeared */
			break;
		default:
			exit( 0);	/* exit the fatherprocess */
	}
#endif

	umask( 066);		/* set filemask */
	chdir( "/var/spool");/* change CurrentWorkDirectory */
	setpgrp();			/* change process-group */

	for (i = 0; i < 10; i++)
		(void) close(i);/* close all open files */

	(void) open("/", 0);/* redirect the std-channels */ 
	(void) dup2(0, 1);
	(void) dup2(0, 2);

	i = open("/dev/tty", O_RDWR);
	if (i >= 0) {
		(void) ioctl(i, (int) TIOCNOTTY, (char *)0);
		(void) close(i);
	}					/* free from tty; change to /dev/null */

	signal( SIGTERM, catchsig);
	signal( SIGKILL, catchsig);

	create_semaphore();

	err = fopen(LPRMESS,"a");
	if (err == (FILE *)0) {
		/* printf("lpd: warning: can't open error-File %s\n",LPRMESS); */
		exit(-1);
	}

	time( &seks);
	
	if ((fd=fopen(LPRSTAT,"rb+")) == (FILE *)0) {
		fprintf(err,"lpd: started: %s",ctime(&seks));
		fflush(err);
		if ((fd=fopen(LPRSTAT,"wb")) == (FILE *)0) {
			fprintf(err,"lpd: error: can't create LPRSTAT\n");
			fclose(err);
			exit(-1);
		}
		fclose(fd);
		fd = fopen(LPRSTAT,"rb+");

	} else {

		fprintf(err,"lpd: started: %s",ctime(&seks));
		fflush(err);
		if (fread(&hd,sizeof(Lpr_h),1,fd) != 1) {
			fprintf(err,"lpd: can't read LPRSTAT\n");
			fclose(fd);
			fclose(err);
			exit(-1);
		}
		if (hd.lpd == EXISTS) {
			err = fopen(LPRMESS,"a");
			fprintf(err,"lpd: it's already running a daemon\n");
			fclose(err);
			fclose(fd);
			exit(0);
		}
	}

	fclose(err);
	hd.lpd = EXISTS;
	hd.pid = getpid();
	rewind(fd);
	fwrite(&hd,sizeof(hd),1,fd);
	fclose(fd);
	free_semaphore();
	for(;;) {
		get_semaphore();
		if ((fd=fopen(LPRSTAT,"rb")) == (FILE *)0) {
			err = fopen(LPRMESS,"a");
			fprintf(err,"lpd: can't open LPRSTAT\n");
			fclose(err);
			exit(0);
		}
		fseek(fd,(long)sizeof(Lpr_h),0);
		if (fread(&dt,sizeof(Lpr_d),1,fd) == 1) {
			fclose(fd);
			free_semaphore();
			print(dt.job,dt.copies);
			continue;
		} else {
			fclose(fd);
			free_semaphore();
		}
#ifndef NODEAMON
		sleep( SLEEPTIME);
#endif
	}
}
