#include <osbind.h>
#include <signal.h>
#include <stdio.h>
#include "lpr.h"

stop_lpd()
{
	FILE   *fd;
	Lpr_h  hd;

	get_semaphore();
	if ((fd = fopen(LPRSTAT,"rb")) != (FILE *)0) {
		if (fread(&hd,sizeof(Lpr_h),1,fd) != 1) {
			printf("file error\n");
			free_semaphore();
			exit(-1);
		}
		fclose(fd);
		free_semaphore();
		kill(hd.pid, SIGTERM);
	}
	exit(0);
}

restart_lpd()
{
	FILE *fd;
	Lpr_h hd;
	char cmdlin[2]="x";

	get_semaphore();
	if ((fd = fopen(LPRSTAT,"rb")) != (FILE *)0) {
		if (fread(&hd,sizeof(Lpr_h),1,fd) != 1) {
			printf("file error\n");
			fclose(fd);
			free_semaphore();
			exit(-1);
		}
		if (hd.lpd == EXISTS) {
			printf("Deamon is already running\n");
			fclose(fd);
			free_semaphore();
			exit(-1);
		}
		fclose(fd);
	}
	free_semaphore();
	*cmdlin = 0;
	Pexec( 200, (char *)LPDPROG, cmdlin, 0); /* run lpd */
	exit(0);
}

void usage( void)
{
	printf("usage: lpstat [-r] [-k]\n");
	printf("       -r: restart lpd\n");
	printf("       -k: kill lpd\n");
	exit(-1);
}

int main(argc,argv)
int argc;
char *argv[];
{
	FILE  *fd;
	Lpr_h hd;

	if (argc > 2) usage();
	if (argc == 2) {
		if (strcmp(argv[1],"-r") == 0) {
			restart_lpd();
		}
		if (strcmp(argv[1],"-k") == 0) {
			stop_lpd();
		}
		usage();
	} else {
		if ((fd = fopen(LPRSTAT,"rb")) != (FILE *)0) {
			fread(&hd,sizeof(Lpr_h),1,fd);
			fclose(fd);
			if (hd.lpd == EXISTS) {
				printf("Daemon is running (pid = %d)\n",hd.pid);
				exit(0);
			}
		}
		printf("no Daemon is running\n");
	}
	exit(0);
}
