#include <stdio.h>
#include "syslog/syslog.h"
#include "lpr.h"

void usage( void)
{
   printf("usage: lprm <job>\n");
   printf("       lprm kill the <job> out of the queue\n");
   exit(-1);
}

int main(argc,argv)
int argc;
char *argv[];
{
	FILE	*fd, *cd;
	char	*logname;
	char	path[132];
	int 	job;
	int 	remove,i;
	Lpr_h	hd;
	Lpr_d	dt;
	extern	char *getlogin();

	if (argc  < 2) usage();
	get_semaphore();
	openlog("lprm", 0, LOG_LPR);
	if ((fd=fopen(LPRSTAT,"rb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open LPRSTAT");
		printf("can't open LPRSTAT\n");
		closelog();
		free_semaphore();
		exit(-1);
	}
	if ((cd = fopen(LPRCP,"wb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open COPY-FILE\n");
		printf("file error\n");
		closelog();
		fclose(fd);
		free_semaphore();
		exit(-1);
	}
	logname = (char *)getlogin();
	fread(&hd,sizeof(Lpr_h),1,fd);
	fwrite(&hd,sizeof(Lpr_h),1,cd);
	for (;;) {
		if (fread(&dt,sizeof(Lpr_d),1,fd) != 1) break;
		remove = 0;
		for (i=(argc-1); i>=1; i--) {
			job = atoi(argv[i]);
			if (dt.job == job) {
				if ((strcmp(dt.owner,logname) == 0)
					|| (strcmp(logname,"root") == 0)) {
					sprintf(path,"u:\\var\\spool\\A%ld",dt.job);
					unlink(path);
					syslog(LOG_NOTICE,"%s removes job %ld\n",logname,dt.job);
					remove = 1;
				} else {
					printf("no permisson to remove job\n");
					syslog(LOG_NOTICE,"%s tried to remove job %ld\n",logname,job);
				}
			}
		}
		if (remove == 0) fwrite(&dt,sizeof(Lpr_d),1,cd);
	}
	closelog();
	fclose(fd);
	fclose(cd);
	fd = fopen(LPRSTAT,"wb");
	cd = fopen(LPRCP,"rb");
	fread(&hd,sizeof(Lpr_h),1,cd);
	fwrite(&hd,sizeof(Lpr_h),1,fd);
	for (;;) {
		if (fread(&dt,sizeof(Lpr_d),1,cd) != 1) break;
		fwrite(&dt,sizeof(Lpr_d),1,fd);
	}
	fclose(fd);
	fclose(cd);
	unlink(LPRCP);
	free_semaphore();
	exit(0);
}
