#include <ctype.h>
#include <memory.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <varargs.h>
#include "lpr.h"

extern int  header;
extern int  len;
extern int  formfeed;
extern int  nummer;
extern int  loeschen;
extern int  translation;
extern int  copy;
extern int  tanz;
extern int  lpd_id;

extern Table liste[256][512];

void schreibe(file,va_alist)
char *file;
va_dcl
{
	FILE	*fd;
	va_list ap;
	char	*format;
	char	zeile[512],*z;
	int 	found,i,j;

#ifdef DEBUG
	printf("writing to file\n");
#endif
	va_start(ap);
	format = va_arg(ap,char *);
	vsprintf(zeile,format,ap);
	va_end(ap);
#ifdef DEBUG
	printf("after varargs\n");
	printf("zeile = ->%s<-\n",zeile);
#endif
/*	if ((fd=fopen(file,"r+")) == (FILE *)0)
 *		fd=fopen(file,"w");
 *	fseek(fd, 0L, 2);
 */
	fd=fopen(file,"a");
#ifdef DEBUG
	printf("after opening file \n");
#endif
	for (z=zeile; *z; z++) {
#ifdef DEBUG
		printf("Check Character %c (%d)\n",*z,*z);
#endif
		if (translation == 1) {
			found = 0;
			for(j = 0; j != tanz; j++) {
#ifdef DEBUG
				printf("character to translate : %c (%d)\n",
				liste[j][0].c,liste[j][0].c);
#endif
				if (*z == liste[j][0].c) {
					for (i=1; i<liste[j][0].anz; i++) {
#ifdef DEBUG
						printf("translate into %c (%d)\n",
						liste[j][i].c,liste[j][i].c);
#endif					 
						fprintf(fd,"%c",liste[j][i].c);
					} /* end of translate liste */
					found = 1;
					break;
				}
			} /* end of liste */
			if (found == 0) fprintf(fd,"%c",*z);
		} /* end of translation */
		else
			fprintf(fd,"%c",*z);
	} /* end of line */
	fclose(fd);
} /* end of schreibe */

void write_file( file, path)
char *file;
char *path;
{
	FILE	*fd;
	char	c;
	char	zeile[256];
	int		i;
	int		line;
	int		pline;
	int		druck;
	int		zeichen;
	int		page, upage;
	int		uline = 0;
	long	size;
	long	seks;
	struct	tm *now;

	if ((fd=fopen(file,"r")) == (FILE *)0) {
		printf("lpr: can't open %s\n",file);
		loeschen=0; /* to avoid the try to unlink the file */
		return;
	}
	fseek(fd,0L,2);
	size = ftell(fd);
	rewind(fd);
	for (;;) {
		if (fread(&c,sizeof(char),1,fd) != 1) break;
		if (c == '\n') uline++;
	}
	rewind(fd);
	if (header == 1) {
		upage = uline / (len -4);
		if ((uline % (len - 4)) > 0) upage++;
	} else {
		upage = uline / len;
		if ((uline % len) > 0) upage++;
	}
	zeichen = druck = line = 0;
	page = 1;
	pline = 1;
	zeile[0] = '\0';
	for (;;) {
		if (fread(&c,sizeof(char),1,fd) != 1) break;
		if (header == 1) {
#ifdef DEBUG
			printf("check to make header\n");
#endif
			if (line == 0) {
#ifdef DEBUG
				printf("constructing header\n");
#endif
				time(&seks);
				now = localtime(&seks);
				sprintf(zeile,"%02d.%02d.%04d  %02d:%02d %s %s page %d from %d (size %ld Bytes)\n",
					now->tm_mday,now->tm_mon+1,now->tm_year + 1900,
						now->tm_hour,now->tm_min,getlogin(),file,
							page,upage,size);
#ifdef DEBUG
				printf("header: ->%s<-\n",zeile);
#endif
				schreibe(path,"%s",zeile);
				zeichen = strlen(zeile);
				for (i=0; i<zeichen; i++) {
					zeile[i] = '-';
				}
				zeile[i++] = '\n';
				zeile[i++] = '\n';
				zeile[i] = '\0';
				schreibe(path,"%s",zeile);
				zeile[0] = '\0';
				line = 4;
				druck = 0;
			}
		}
		if (strlen(zeile) == 0) {
#ifdef DEBUG
			printf("empty line, have i to numbering the line?\n");
#endif
			if (nummer == 1) {
#ifdef DEBUG
				printf("numbering line\n");
#endif
				sprintf(zeile,"%-4d ",pline);
			}
		}
		zeichen = strlen(zeile);
		if (zeichen >= 255) {
			schreibe(path,"%s",zeile);
			zeile[0] = '\0';
		}
		druck = 1;
		zeile[zeichen++] = c;
		zeile[zeichen] = '\0';
		if (c == '\n') {
			schreibe(path,"%s",zeile);
			zeile[0] = '\0';
			druck = 0;
			line++;
			pline++;
		}
		if (line == len) {
#ifdef DEBUG
			printf("line ist full. print it out\n");
#endif
			sprintf(zeile,"\014");
			schreibe(path,"%s",zeile);
			zeile[0] = '\0';
			druck = 0;
			line = 0;
			page++;
		}
	}
	if (druck == 1) {
#ifdef DEBUG
		printf("i've print the rest\n");
#endif
		schreibe(path,"%s",zeile);
	}
	if (formfeed == 1) {
#ifdef DEBUG
		printf("i have now to print a formfeed\n");
#endif
		sprintf(zeile,"\014");
		schreibe(path,"%s",zeile);
	}
}

void copy_file( file, path)
char *file;
char *path;
{
	FILE	*fd, *cd;
	char	*buff;
	int		bread;

	if ((fd=fopen(file,"r")) == (FILE *)0) {
		printf("lpr: can't open %s\n",file);
		loeschen = 0; /* to avoid the try to unlink the file */
		return;
	}
	if ((cd=fopen(path,"w")) == (FILE *)0) {
		printf("lpr: can't open %s\n",file);
		return;
	}
	if (!(buff = (char *)malloc( BUFSIZE))) {
		printf("lpr: not enough memory\n");
		return;
	}
	do {
		bread = fread( buff, 1, BUFSIZE, fd);
		fwrite( buff, 1, bread, cd);
	} while ( bread == BUFSIZE);
	fclose(cd);
	fclose(fd);
}
